%% Rotina para importar videos, extrair data frames e processar imagens
% Utilizada na disciplina de Mecnica dos Fluidos Ambiental I/2019
% Experimento adveco/difuso
% Lediane Marcon
clear all
close all
clc

%% Importar video e definir frames
[FileName,PathName]=uigetfile('*.mp4');
v = VideoReader([PathName,FileName]);
Nframes = v.NumberOfFrames;
Frate = v.FrameRate;

%%variveis que podem ser alteradas
dt = 1; %intervalo de tempo entre imagens em segundos
nimag = 4; % nmero de imagens que ser salvas

%%processamento
warning('off','all')
%Imagem inicial: background
frames = read(v,1);
imwrite(frames,['Image' int2str(1), '.jpg']); figure; imshow(frames)
I1=rgb2gray(frames); figure; imshow(I1); xlswrite('ImageGrey1.xlsx',I1)
imwrite(I1,['ImageGrey' int2str(i), '.jpg']);
I2=histeq(I1); figure; imshow(I2); xlswrite(['ImageContrast1.xlsx'],I2);

% outras imagens com pluma
for i=2:nimag
    fnumber = 1+(i*Frate*dt);
    frames = read(v,fnumber);
    imwrite(frames,['Image' int2str(i), '.jpg']); figure; imshow(frames)
    %Converso rgb para escala de cinza
    I1=rgb2gray(frames); figure; imshow(I1); xlswrite(['ImageGrey' int2str(i), '.xlsx'],I1)
    imwrite(I1,['ImageGrey' int2str(i), '.jpg']);
    
    % Processamento adicional
    % Ajusta a escala de cinza para aumentar o contraste da imagem
    I2=histeq(I1); figure; imshow(I2)
    xlswrite(['ImageContrast' int2str(i), '.xlsx'],I2);
    
    clear frames I1 I2
end


